package com.example.afrishop_v3.repository;

import com.example.afrishop_v3.models.TbCfCartRecordR;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Optional;

public interface TbCfCartRecordRRepository extends PagingAndSortingRepository<TbCfCartRecordR, String> {
    int countByUserId(String userId);

    Optional<TbCfCartRecordR> findFirstByUserIdAndItemIdAndItemSku(String userId, String itemId, String itemSku);

    Optional<TbCfCartRecordR> findFirstByUserIdAndItemImgAndItemSku(String userId, String itemImg, String itemSku);

    Optional<TbCfCartRecordR> findFirstByUserIdAndSourceItemIdAndItemSku(String userId, String sourceItemId, String itemSku);
    @Query(value = "select a from #{#entityName} a left join TbCfStationItem x on a.itemId=x.itemId WHERE  a.userId=:userId and (x.enableFlag =1 or x.enableFlag IS NULL)   order by a.createTime desc   ")
    List<TbCfCartRecordR> findAllByUserIdOrderByCreateTimeDesc(@Param("userId") String userId);
    List<TbCfCartRecordR> findAllByCartRecordIdIn(String[] ids);


    @Transactional
    void deleteAllByCartRecordIdIn(String[] ids);
}
